from typing import Dict, Any

from core.config import CoreConfig
from titles.chuni.sunplus import ChuniSunPlus
from titles.chuni.const import ChuniConstants
from titles.chuni.config import ChuniConfig


class ChuniLuminous(ChuniSunPlus):
    def __init__(self, core_cfg: CoreConfig, game_cfg: ChuniConfig) -> None:
        super().__init__(core_cfg, game_cfg)
        self.version = ChuniConstants.VER_CHUNITHM_LUMINOUS

    def handle_cm_get_user_preview_api_request(self, data: Dict) -> Dict:
        user_data = super().handle_cm_get_user_preview_api_request(data)

        # I don't know if lastDataVersion is going to matter, I don't think CardMaker 1.35 works this far up
        user_data["lastDataVersion"] = "2.20.00"
        return user_data

    async def handle_get_user_c_mission_api_request(self,data: Dict) -> Dict:
        c_mission_list = await self.data.profile.get_profile_c_mission(data["userId"])
        if c_mission_list is None:
            return {
                "userId": data["userId"],
                "length": 0,
                "userCMissionList": [],
            }

        c_mission = c_mission_list._asdict()
        c_mission.pop("id")
        c_mission.pop("user")

        return c_mission


